--- logger.c.orig	2010-02-24 16:23:35.000000000 -0500
+++ logger.c	2010-03-23 10:02:47.000000000 -0500
@@ -414,34 +414,55 @@
 	va_list ap;
 	char qlog_msg[8192];
 	int qlog_len;
-	char time_str[16];
-
-	if (ast_check_realtime("queue_log")) {
-		va_start(ap, fmt);
-		vsnprintf(qlog_msg, sizeof(qlog_msg), fmt, ap);
-		va_end(ap);
-		snprintf(time_str, sizeof(time_str), "%ld", (long)time(NULL));
-		ast_store_realtime("queue_log", "time", time_str, 
-						"callid", callid, 
-						"queuename", queuename, 
-						"agent", agent, 
-						"event", event,
-						"data", qlog_msg,
-						NULL);
-	} else {
-		if (qlog) {
-			va_start(ap, fmt);
-			qlog_len = snprintf(qlog_msg, sizeof(qlog_msg), "%ld|%s|%s|%s|%s|", (long)time(NULL), callid, queuename, agent, event);
-			vsnprintf(qlog_msg + qlog_len, sizeof(qlog_msg) - qlog_len, fmt, ap);
-			va_end(ap);
-		}
-		AST_RWLIST_RDLOCK(&logchannels);
-		if (qlog) {
-			fprintf(qlog, "%s\n", qlog_msg);
-			fflush(qlog);
-		}
-		AST_RWLIST_UNLOCK(&logchannels);
-	}
+	char time_str[30];
+	struct tm *tmPtr;
+	time_t timenow;
+	const char *delims = "|";
+	size_t start = 0;
+	int i = 0;
+	char qlogdata[4][100]={"","","",""};
+	
+        if (ast_check_realtime("queue_log")) {
+                va_start(ap, fmt);
+                vsnprintf(qlog_msg, sizeof(qlog_msg), fmt, ap);
+                va_end(ap);
+		timenow = time(NULL);
+		tmPtr = localtime(&timenow);
+		strftime(time_str, sizeof(time_str), "%Y-%m-%d %H:%M:%S", tmPtr);
+
+		/*Explode the queue log parameters*/
+		while (qlog_msg[start] != '\0') {
+	                size_t end = strcspn(qlog_msg + start, delims);
+			strncpy(qlogdata[i],qlog_msg + start, end);
+			ast_debug(1,"Parameter %d of queue_log: %s\n", i, qlogdata[i]);
+	                start += (qlog_msg[start + end] != '\0') ? end + 1 : end;
+			i++;
+	        }
+		
+                ast_store_realtime("queue_log", "eventdate", time_str,
+                                                "cdr_uniqueid", callid,
+                                                "queuename", queuename,
+                                                "agent", agent,
+                                                "event", event,
+                                                "data1", qlogdata[0],
+						"data2", qlogdata[1],
+						"data3", qlogdata[2],
+						"data4", qlogdata[3],
+                                                NULL);
+        }
+
+        if (qlog) {
+                va_start(ap, fmt);
+                qlog_len = snprintf(qlog_msg, sizeof(qlog_msg), "%ld|%s|%s|%s|%s|", (long)time(NULL), callid, queuename, agent, event); 
+                vsnprintf(qlog_msg + qlog_len, sizeof(qlog_msg) - qlog_len, fmt, ap);
+                va_end(ap);
+        }
+        AST_RWLIST_RDLOCK(&logchannels);
+        if (qlog) {
+                fprintf(qlog, "%s\n", qlog_msg);
+                fflush(qlog);
+        }
+        AST_RWLIST_UNLOCK(&logchannels);
 }
 
 static int rotate_file(const char *filename)
